/**
 * Notes
 */

@-webkit-keyframes targe3-note {
  from { background: #fffff0; }
  50% { background: #ffffd3; }
  to { background: #fffff0; }
}

ul.notes {
  display: block;
  list-style: none;
  margin: 0;
  padding: 0;

  .timeline-icon {
    float: left;
  }

  .timeline-content {
    margin-left: 55px;

    &.timeline-content-form {
      @media (max-width: $screen-sm-max) {
        margin-left: 0;
      }
    }
  }

  .note-created-ago, .note-updated-at {
    white-space: nowrap;
  }

  .system-note {
    font-size: 14px;
    padding-top: 10px;
    padding-bottom: 10px;
    background: #fdfdfd;

    .timeline-icon {
      .avatar {
        visibility: hidden;
      }
    }
  }

  .discussion-body {
    padding-top: 15px;
  }

  .discussion {
    overflow: hidden;
    display: block;
    position: relative;
  }

  .note {
    display: block;
    position: relative;
    border-bottom: 1px solid $table-border-gray;

    &.is-editting {
      .note-header,
      .note-text,
      .edited-text {
        display: none;
      }

      .note-edit-form {
        display: block;
      }
    }

    .note-body {
      overflow: auto;

      .note-text {
        overflow: auto;
        word-wrap: break-word;
        @include md-typography;

        // On diffs code should wrap nicely and not overflow
        code {
          white-space: pre-wrap;
        }

        // Reset ul style types since we're nested inside a ul already
        & > ul {
          list-style-type: disc;

          ul {
            list-style-type: circle;

            ul {
              list-style-type: square;
            }
          }
        }

        ul.task-list {
          ul:not(.task-list) {
            padding-left: 1.3em;
          }
        }

        hr {
          // Darken 'whitesmoke' a bit to make it more visible in note bodies
          border-color: darken(#f5f5f5, 8%);
          margin: 10px 0;
        }

        code {
          word-break: keep-all;
        }
      }

      a {
        word-break: break-all;
      }
    }

    .note-header {
      padding-bottom: 3px;
    }

  }
}

// Diff code in discussion view
.discussion-body .diff-file {
  .diff-header > span {
    margin-right: 10px;
  }
  .line_content {
    white-space: pre-wrap;
  }
}

.diff-file .notes_holder {
  font-family: $regular_font;

  td {
    border: 1px solid $table-border-gray;
    border-left: none;

    &.notes_line {
      vertical-align: middle;
      text-align: center;
      padding: 10px 0;
      background: $background-color;
      color: $text-color;
    }

    &.notes_line2 {
      text-align: center;
      padding: 10px 0;
      border-left: 1px solid #ddd !important;
    }

    &.notes_content {
      background-color: $background-color;
      border-width: 1px 0;
      padding: 0;
      vertical-align: top;
      white-space: normal;

      &.parallel {
        border-width: 1px;
      }

      .notes {
        background-color: $white-light;
      }
    }
  }
}

.discussion-header,
.note-header {
  a {
    color: inherit;

    &:hover {
      color: $gl-link-color;
      text-decoration: none;
    }
  }

  .author_link {
    color: $gl-gray;
  }
}

.note-headline-light,
.discussion-headline-light {
  color: $notes-light-color;
}

.discussion-headline-light {
  a {
    color: $gl-link-color;
  }
}

/**
 * Actions for Discussions/Notes
 */

.discussion-actions,
.note-actions {
  float: right;
  margin-left: 10px;
  color: $notes-action-color;
}

.discussion-actions {
  @media (max-width: $screen-md-max) {
    float: none;
    margin-left: 0;

    .note-action-button {
      margin-left: 0;
    }
  }
}

.note-action-button,
.discussion-action-button {
  display: inline-block;
  margin-left: 10px;
  line-height: 24px;

  .fa {
    color: $notes-action-color;
    position: relative;
    top: 1px;
    font-size: 17px;
  }

  &.js-note-delete {
    i {
      &:hover {
        color: $gl-text-red;
      }
    }
  }

  &.js-note-edit {
    i {
      &:hover {
        color: $gl-link-color;
      }
    }
  }
}

.discussion-toggle-button {
  line-height: 20px;
  font-size: 13px;

  .fa {
    margin-right: 3px;
    font-size: 10px;
    line-height: 18px;
    vertical-align: top;
  }
}

.note-role {
  position: relative;
  top: -2px;
  display: inline-block;
  padding-left: 4px;
  padding-right: 4px;
  color: $notes-role-color;
  font-size: 12px;
  line-height: 20px;
  border: 1px solid $notes-role-border-color;
  border-radius: $border-radius-base;
}

.diff-file .note .note-actions {
  right: 0;
  top: 0;
}


/**
 * Line note button on the side of diffs
 */

.diff-file tr.line_holder {
  @mixin show-add-diff-note {
    display: inline-block;
  }

  .add-diff-note {
    margin-top: -4px;
    @include border-radius(40px);
    background: #fff;
    padding: 4px;
    font-size: 16px;
    color: $gl-link-color;
    margin-left: -56px;
    position: absolute;
    z-index: 10;
    width: 32px;
    // "hide" it by default
    display: none;
    &:hover {
      background: $gl-info;
      color: #fff;
      @include show-add-diff-note;
    }
  }

  // "show" the icon also if we just hover somewhere over the line
  &:hover > td {
    .add-diff-note {
      @include show-add-diff-note;
    }
  }
}

.disabled-comment {
  margin-left: -$gl-padding-top;
  margin-right: -$gl-padding-top;
  background-color: $gray-light;
  border-radius: $border-radius-base;
  border: 1px solid $border-gray-normal;
  color: $note-disabled-comment-color;
  line-height: 200px;

  .disabled-comment-text {
    line-height: normal;
  }

  a {
    color: $gl-link-color;
  }
}
